import * as theia from '@theia/plugin';
import { RPCProtocol } from '../common/rpc-protocol';
import { QueryParameters } from '../common/env';
export declare abstract class EnvExtImpl {
    protected readonly rpc: RPCProtocol;
    private proxy;
    private queryParameters;
    private lang;
    private applicationName;
    private ui;
    private envMachineId;
    private envSessionId;
    private host;
    private applicationRoot;
    private _remoteName;
    constructor();
    initialize(): void;
    getEnvVariable(envVarName: string): Promise<string | undefined>;
    getQueryParameter(queryParamName: string): string | string[] | undefined;
    getQueryParameters(): QueryParameters;
    setQueryParameters(queryParams: QueryParameters): void;
    setApplicationName(applicationName: string): void;
    setLanguage(lang: string): void;
    setUIKind(uiKind: theia.UIKind): void;
    setAppHost(appHost: string): void;
    setAppRoot(appRoot: string): void;
    getClientOperatingSystem(): Promise<theia.OperatingSystem>;
    get appName(): string;
    get appRoot(): string;
    abstract get isNewAppInstall(): boolean;
    get appHost(): string;
    get remoteName(): string | undefined;
    get language(): string;
    get machineId(): string;
    get sessionId(): string;
    get uriScheme(): string;
    get uiKind(): theia.UIKind;
}
//# sourceMappingURL=env.d.ts.map